/*
    This file is part of ldbi.

    ldbi is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ldbi is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with ldbi.  If not, see <http://www.gnu.org/licenses/>.

    Copyright (C) 2008 - 2010 Lucas Hermann Negri
*/

#include "ldbi.h"

void ldbi_push_metatable(lua_State* L, const char* name, const luaL_reg* methods,
    lua_CFunction gc, lua_CFunction tostring)
{
    luaL_newmetatable(L, name);

    /* Methods */
    luaL_openlib(L, NULL, methods, 0);

    /* __gc */
    lua_pushstring(L, "__gc");
    lua_pushcfunction(L, gc);
    lua_settable (L, -3);

    /* __tostring */
    lua_pushstring(L, "__tostring");
    lua_pushcfunction(L, tostring);
    lua_settable (L, -3);

    /* __index */
    lua_pushstring(L, "__index");
    lua_pushvalue(L, -2);
    lua_settable (L, -3);
}
